<?php

namespace Labrender\FileRepository;

use User;

class FileRepository
{
    /**
     * $notifications object.
     */
    protected $notifications;    /**
     * $attachments object.
     */
    protected $attachments;

    /**
     * Constructor.
     */
    public function __construct(\Labrender\FileRepository\Interfaces\NotificationsRepositoryInterface $notifications,        \Labrender\FileRepository\Interfaces\AttachmentsRepositoryInterface $attachments)
    {
        $this->notifications = $notifications;        $this->attachments = $attachments;
    }

    /**
     * Returns count of file_repository.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.notifications.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->notifications->pushCriteria(new \Litepie\Labrender\Repositories\Criteria\NotificationsUserCriteria());
        }

        $notifications = $this->notifications->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('file_repository::' . $view, compact('notifications'))->render();
    }    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.attachments.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->attachments->pushCriteria(new \Litepie\Labrender\Repositories\Criteria\AttachmentsUserCriteria());
        }

        $attachments = $this->attachments->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('file_repository::' . $view, compact('attachments'))->render();
    }
}
